﻿Public Class Form1
    Private Data As Byte()
    Private ReadOnly Latin1 As System.Text.Encoding = System.Text.Encoding.GetEncoding("iso-8859-1")
   Private ReadOnly ListOfUserData As New List(Of Tuple(Of String, String))
   Private Const _256_3 As UInt32 = 16777216UI
   Private Const _256_2 As UInt32 = 65536UI
   Public Sub New()
      InitializeComponent()
      ListBox1.DisplayMember = "Item1"
      ListBox1.ValueMember = "Item2"
   End Sub
   Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
      Dim path As String = Environment.GetFolderPath(Environment.SpecialFolder.Desktop) + "\Testdatei.txt"
      path = "..\..\Testdatei.txt"
      If Not System.IO.File.Exists(path) Then
         Return
      End If
      Me.Data = System.IO.File.ReadAllBytes(path)
      ListOfUserData.Clear()
      For i As Integer = 0 To Data.Length - 4 Step 1
         If $"{Convert.ToChar(Data(i))}{Convert.ToChar(Data(i + 1))}{Convert.ToChar(Data(i + 2))}{Convert.ToChar(Data(i + 3))}" = "udta" Then
            Get_UserData(i)
         End If
      Next
      'for test: create dummi-userdata
      Me.ListOfUserData.Add(Tuple.Create("dummi1", String.Concat(Enumerable.Repeat("dummi1 ", 100))))
      Me.ListOfUserData.Add(Tuple.Create("dummi2", String.Concat(Enumerable.Repeat("dummi2_", 100))))
      ListBox1.DataSource = Nothing : ListBox1.DataSource = ListOfUserData
   End Sub

   Private Sub Get_UserData(i As Integer)
      Dim boxSize0 As UInt32 = Data(i - 4) * _256_3 + Data(i - 3) * _256_2 + Data(i - 2) * 256UI + Data(i - 1)

      For j As Integer = i + 8 To i + CInt(boxSize0) - 8 Step 1 ' nicht 4
         If Latin1.GetString({Data(j), Data(j + 1), Data(j + 2), Data(j + 3)}) = "data" Then
            Dim boxSize1 As UInt32 = Data(j - 4) * _256_3 + Data(j - 3) * _256_2 + Data(j - 2) * 256UI + Data(j - 1)
            'Dim processedData As Byte() = New Byte(CInt(boxSize1) - 8 - 1) {}
            ''Array.Copy(Data, j + 4, processedData, 0, processedData.Length)
            'Using ms As New IO.MemoryStream(Me.Data)
            '   ms.Seek(j + 4, IO.SeekOrigin.Begin)
            '   ms.Read(processedData, 0, processedData.Length)
            'End Using
            ''Dim processedData = Me.Data.Skip(j + 4).Take(CInt(boxSize1) - 8).ToArray
            'Dim obtainedString As String = System.Text.Encoding.UTF8.GetString(processedData).TrimStart({NullChar, Convert.ToChar(1), Convert.ToChar(24)})
            '                              UTF8 according to the standard
            Dim obtainedString = System.Text.Encoding.UTF8.GetString(Me.Data, j + 4, CInt(boxSize1) - 8).TrimStart({NullChar, Convert.ToChar(1), Convert.ToChar(24)})
            Dim itm1 = New String(obtainedString.Take(50).ToArray)
            Me.ListOfUserData.Add(Tuple.Create(itm1, obtainedString))
            j += CInt(boxSize1) - 1 ' Do NOT write "Exit For" because these are single items
         End If
      Next
   End Sub

   Private Sub ListBox1_SelectedValueChanged(sender As Object, e As EventArgs) Handles ListBox1.SelectedValueChanged
      RichTextBox1.Text = ListBox1.SelectedValue?.ToString
   End Sub

End Class